using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using zx.matrix;

namespace TestSender
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class FormMain : System.Windows.Forms.Form
	{
    private System.Windows.Forms.Panel panel4;
    private System.Windows.Forms.TextBox txtMsg;
    private System.Windows.Forms.Panel panelSend;
    private System.Windows.Forms.Button btnClose;
    private System.Windows.Forms.TextBox txtMsgNum;
    private System.Windows.Forms.Label label2;
    private System.Windows.Forms.Panel panel2;
    private System.Windows.Forms.Button btnSend;
    private System.Windows.Forms.Label labelConnection;
    private System.Windows.Forms.Label label3;
    private System.Windows.Forms.Panel panelClose;
    private System.Windows.Forms.Panel panelInfo;
    private System.Windows.Forms.Panel panel1;
    private System.Windows.Forms.Panel panelInfoSend;
    private System.Windows.Forms.Label labelNumberOfSent;
    private System.Windows.Forms.Label label1;
    private System.Windows.Forms.Panel panel3;
    private System.Windows.Forms.Button btnConnectionApply;
    private System.Windows.Forms.TextBox tbConnectionPassword;
    private System.Windows.Forms.TextBox tbAvailableHosts;
    private System.Windows.Forms.Label label6;
    private System.Windows.Forms.Label label5;

    private const string Version = "1.4";
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FormMain()
		{
          InitializeComponent();
          // Initialize the matrix
          CMatrixSubsystem.Start("TestSender", Version);
          
          // Reset the information labels
          labelNumberOfSent.Text = "";
          btnSend.Enabled = false;

          // Set connected handlers
          CMatrixSubsystem.Subscribe(new zx.matrix.CEventConnected(), 
                                     new CControlMethodMessageHandler(new ProcessHandle(WhenConnectedEvent), 
                                                                      labelConnection), 
                                     CMatrixSubsystem.ESubscriptionType.Event);
          CMatrixSubsystem.Subscribe(new zx.matrix.CEventDisconnected(), 
                                     new CControlMethodMessageHandler(new ProcessHandle(WhenDisconnectedEvent), 
                                                                                        labelConnection), 
                                     CMatrixSubsystem.ESubscriptionType.Event);
		}

	//==========================================================================
	// Connected event handlers
	private void WhenConnectedEvent(zx.matrix.CMessage aMsg, zx.matrix.CAddress aAddr)
	{
      btnSend.Enabled = !mIsSendingEvent.WaitOne(0, true); // cannot be set to enabled during sending
	  labelConnection.ForeColor = System.Drawing.Color.LightGreen;
	  labelConnection.Text = CMatrixSubsystem.GetMasterAddress().GetFullName();
	}
	private void WhenDisconnectedEvent(zx.matrix.CMessage aMsg, zx.matrix.CAddress aAddr)
	{
      btnSend.Enabled = false;
	  labelConnection.ForeColor = System.Drawing.Color.Red;
	  labelConnection.Text = "Disconnected";
	}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(FormMain));
      this.panelClose = new System.Windows.Forms.Panel();
      this.btnClose = new System.Windows.Forms.Button();
      this.panelSend = new System.Windows.Forms.Panel();
      this.panel2 = new System.Windows.Forms.Panel();
      this.btnSend = new System.Windows.Forms.Button();
      this.label2 = new System.Windows.Forms.Label();
      this.txtMsgNum = new System.Windows.Forms.TextBox();
      this.panelInfo = new System.Windows.Forms.Panel();
      this.tbConnectionPassword = new System.Windows.Forms.TextBox();
      this.tbAvailableHosts = new System.Windows.Forms.TextBox();
      this.label6 = new System.Windows.Forms.Label();
      this.label5 = new System.Windows.Forms.Label();
      this.panel3 = new System.Windows.Forms.Panel();
      this.btnConnectionApply = new System.Windows.Forms.Button();
      this.panel1 = new System.Windows.Forms.Panel();
      this.panelInfoSend = new System.Windows.Forms.Panel();
      this.labelNumberOfSent = new System.Windows.Forms.Label();
      this.label1 = new System.Windows.Forms.Label();
      this.labelConnection = new System.Windows.Forms.Label();
      this.label3 = new System.Windows.Forms.Label();
      this.panel4 = new System.Windows.Forms.Panel();
      this.txtMsg = new System.Windows.Forms.TextBox();
      this.panelClose.SuspendLayout();
      this.panelSend.SuspendLayout();
      this.panel2.SuspendLayout();
      this.panelInfo.SuspendLayout();
      this.panel3.SuspendLayout();
      this.panel1.SuspendLayout();
      this.panelInfoSend.SuspendLayout();
      this.panel4.SuspendLayout();
      this.SuspendLayout();
      // 
      // panelClose
      // 
      this.panelClose.BackColor = System.Drawing.SystemColors.ControlDark;
      this.panelClose.Controls.Add(this.btnClose);
      this.panelClose.Dock = System.Windows.Forms.DockStyle.Bottom;
      this.panelClose.Location = new System.Drawing.Point(0, 315);
      this.panelClose.Name = "panelClose";
      this.panelClose.Size = new System.Drawing.Size(674, 58);
      this.panelClose.TabIndex = 0;
      // 
      // btnClose
      // 
      this.btnClose.Anchor = System.Windows.Forms.AnchorStyles.None;
      this.btnClose.BackColor = System.Drawing.SystemColors.Control;
      this.btnClose.Location = new System.Drawing.Point(286, 12);
      this.btnClose.Name = "btnClose";
      this.btnClose.Size = new System.Drawing.Size(120, 33);
      this.btnClose.TabIndex = 0;
      this.btnClose.Text = "Close";
      this.btnClose.UseVisualStyleBackColor = false;
      this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
      // 
      // panelSend
      // 
      this.panelSend.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
      this.panelSend.Controls.Add(this.panel2);
      this.panelSend.Controls.Add(this.label2);
      this.panelSend.Controls.Add(this.txtMsgNum);
      this.panelSend.Dock = System.Windows.Forms.DockStyle.Bottom;
      this.panelSend.Location = new System.Drawing.Point(0, 256);
      this.panelSend.Name = "panelSend";
      this.panelSend.Size = new System.Drawing.Size(674, 59);
      this.panelSend.TabIndex = 1;
      // 
      // panel2
      // 
      this.panel2.Controls.Add(this.btnSend);
      this.panel2.Dock = System.Windows.Forms.DockStyle.Right;
      this.panel2.Location = new System.Drawing.Point(522, 0);
      this.panel2.Name = "panel2";
      this.panel2.Size = new System.Drawing.Size(148, 55);
      this.panel2.TabIndex = 3;
      // 
      // btnSend
      // 
      this.btnSend.Location = new System.Drawing.Point(11, 10);
      this.btnSend.Name = "btnSend";
      this.btnSend.Size = new System.Drawing.Size(120, 34);
      this.btnSend.TabIndex = 3;
      this.btnSend.Text = "Send";
      this.btnSend.Click += new System.EventHandler(this.btnSend_Click);
      // 
      // label2
      // 
      this.label2.AutoSize = true;
      this.label2.Location = new System.Drawing.Point(10, 16);
      this.label2.Name = "label2";
      this.label2.Size = new System.Drawing.Size(160, 20);
      this.label2.TabIndex = 1;
      this.label2.Text = "Number of messages";
      // 
      // txtMsgNum
      // 
      this.txtMsgNum.Location = new System.Drawing.Point(205, 12);
      this.txtMsgNum.Name = "txtMsgNum";
      this.txtMsgNum.Size = new System.Drawing.Size(89, 26);
      this.txtMsgNum.TabIndex = 0;
      this.txtMsgNum.Text = "100";
      // 
      // panelInfo
      // 
      this.panelInfo.BackColor = System.Drawing.SystemColors.ControlDark;
      this.panelInfo.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
      this.panelInfo.Controls.Add(this.tbConnectionPassword);
      this.panelInfo.Controls.Add(this.tbAvailableHosts);
      this.panelInfo.Controls.Add(this.label6);
      this.panelInfo.Controls.Add(this.label5);
      this.panelInfo.Controls.Add(this.panel3);
      this.panelInfo.Controls.Add(this.panel1);
      this.panelInfo.Controls.Add(this.labelConnection);
      this.panelInfo.Controls.Add(this.label3);
      this.panelInfo.Dock = System.Windows.Forms.DockStyle.Top;
      this.panelInfo.Location = new System.Drawing.Point(0, 0);
      this.panelInfo.Name = "panelInfo";
      this.panelInfo.Size = new System.Drawing.Size(674, 140);
      this.panelInfo.TabIndex = 2;
      // 
      // tbConnectionPassword
      // 
      this.tbConnectionPassword.Location = new System.Drawing.Point(205, 56);
      this.tbConnectionPassword.Name = "tbConnectionPassword";
      this.tbConnectionPassword.Size = new System.Drawing.Size(205, 26);
      this.tbConnectionPassword.TabIndex = 20;
      // 
      // tbAvailableHosts
      // 
      this.tbAvailableHosts.Location = new System.Drawing.Point(205, 23);
      this.tbAvailableHosts.Name = "tbAvailableHosts";
      this.tbAvailableHosts.Size = new System.Drawing.Size(205, 26);
      this.tbAvailableHosts.TabIndex = 19;
      // 
      // label6
      // 
      this.label6.AutoSize = true;
      this.label6.ForeColor = System.Drawing.SystemColors.ActiveCaptionText;
      this.label6.Location = new System.Drawing.Point(13, 58);
      this.label6.Name = "label6";
      this.label6.Size = new System.Drawing.Size(166, 20);
      this.label6.TabIndex = 18;
      this.label6.Text = "Connection password:";
      // 
      // label5
      // 
      this.label5.AutoSize = true;
      this.label5.ForeColor = System.Drawing.SystemColors.ActiveCaptionText;
      this.label5.Location = new System.Drawing.Point(13, 32);
      this.label5.Name = "label5";
      this.label5.Size = new System.Drawing.Size(119, 20);
      this.label5.TabIndex = 17;
      this.label5.Text = "Available hosts:";
      // 
      // panel3
      // 
      this.panel3.Controls.Add(this.btnConnectionApply);
      this.panel3.Dock = System.Windows.Forms.DockStyle.Right;
      this.panel3.Location = new System.Drawing.Point(516, 0);
      this.panel3.Name = "panel3";
      this.panel3.Size = new System.Drawing.Size(154, 101);
      this.panel3.TabIndex = 16;
      // 
      // btnConnectionApply
      // 
      this.btnConnectionApply.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
      this.btnConnectionApply.BackColor = System.Drawing.SystemColors.Control;
      this.btnConnectionApply.Location = new System.Drawing.Point(18, 34);
      this.btnConnectionApply.Name = "btnConnectionApply";
      this.btnConnectionApply.Size = new System.Drawing.Size(120, 33);
      this.btnConnectionApply.TabIndex = 4;
      this.btnConnectionApply.Text = "Apply";
      this.btnConnectionApply.UseVisualStyleBackColor = false;
      this.btnConnectionApply.Click += new System.EventHandler(this.btnConnectionApply_Click);
      // 
      // panel1
      // 
      this.panel1.BackColor = System.Drawing.Color.DarkGray;
      this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
      this.panel1.Controls.Add(this.panelInfoSend);
      this.panel1.Controls.Add(this.label1);
      this.panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
      this.panel1.Location = new System.Drawing.Point(0, 101);
      this.panel1.Name = "panel1";
      this.panel1.Size = new System.Drawing.Size(670, 35);
      this.panel1.TabIndex = 12;
      // 
      // panelInfoSend
      // 
      this.panelInfoSend.BackColor = System.Drawing.Color.DarkGray;
      this.panelInfoSend.Controls.Add(this.labelNumberOfSent);
      this.panelInfoSend.Dock = System.Windows.Forms.DockStyle.Right;
      this.panelInfoSend.Location = new System.Drawing.Point(438, 0);
      this.panelInfoSend.Name = "panelInfoSend";
      this.panelInfoSend.Size = new System.Drawing.Size(230, 33);
      this.panelInfoSend.TabIndex = 14;
      // 
      // labelNumberOfSent
      // 
      this.labelNumberOfSent.AutoSize = true;
      this.labelNumberOfSent.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.labelNumberOfSent.ForeColor = System.Drawing.SystemColors.Info;
      this.labelNumberOfSent.Location = new System.Drawing.Point(13, 7);
      this.labelNumberOfSent.Name = "labelNumberOfSent";
      this.labelNumberOfSent.Size = new System.Drawing.Size(172, 20);
      this.labelNumberOfSent.TabIndex = 0;
      this.labelNumberOfSent.Text = "labelNumberOfSent";
      // 
      // label1
      // 
      this.label1.AutoSize = true;
      this.label1.ForeColor = System.Drawing.SystemColors.ActiveCaptionText;
      this.label1.Location = new System.Drawing.Point(6, 6);
      this.label1.Name = "label1";
      this.label1.Size = new System.Drawing.Size(136, 20);
      this.label1.TabIndex = 13;
      this.label1.Text = "Message content:";
      // 
      // labelConnection
      // 
      this.labelConnection.AutoSize = true;
      this.labelConnection.Font = new System.Drawing.Font("Courier New", 9F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.labelConnection.ForeColor = System.Drawing.Color.Red;
      this.labelConnection.Location = new System.Drawing.Point(205, 1);
      this.labelConnection.Name = "labelConnection";
      this.labelConnection.Size = new System.Drawing.Size(141, 20);
      this.labelConnection.TabIndex = 11;
      this.labelConnection.Text = "Disconnected";
      // 
      // label3
      // 
      this.label3.AutoSize = true;
      this.label3.ForeColor = System.Drawing.SystemColors.ActiveCaptionText;
      this.label3.Location = new System.Drawing.Point(13, 3);
      this.label3.Name = "label3";
      this.label3.Size = new System.Drawing.Size(94, 20);
      this.label3.TabIndex = 10;
      this.label3.Text = "Connection:";
      // 
      // panel4
      // 
      this.panel4.Controls.Add(this.txtMsg);
      this.panel4.Dock = System.Windows.Forms.DockStyle.Fill;
      this.panel4.Location = new System.Drawing.Point(0, 140);
      this.panel4.Name = "panel4";
      this.panel4.Size = new System.Drawing.Size(674, 116);
      this.panel4.TabIndex = 3;
      // 
      // txtMsg
      // 
      this.txtMsg.AcceptsReturn = true;
      this.txtMsg.AcceptsTab = true;
      this.txtMsg.Dock = System.Windows.Forms.DockStyle.Fill;
      this.txtMsg.Location = new System.Drawing.Point(0, 0);
      this.txtMsg.Multiline = true;
      this.txtMsg.Name = "txtMsg";
      this.txtMsg.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
      this.txtMsg.Size = new System.Drawing.Size(674, 116);
      this.txtMsg.TabIndex = 0;
      this.txtMsg.Text = "      for (int i = outPos; i < aBuf.Length && aBuf[i] != 0; i++)\r\n        s += Co" +
    "nvert.ToChar(aBuf[i]);";
      // 
      // FormMain
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(8, 19);
      this.ClientSize = new System.Drawing.Size(674, 373);
      this.Controls.Add(this.panel4);
      this.Controls.Add(this.panelInfo);
      this.Controls.Add(this.panelSend);
      this.Controls.Add(this.panelClose);
      this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
      this.MaximumSize = new System.Drawing.Size(800, 877);
      this.MinimumSize = new System.Drawing.Size(589, 292);
      this.Name = "FormMain";
      this.Text = "TestSender (version " + Version + ")";
      this.Closing += new System.ComponentModel.CancelEventHandler(this.FormMain_Closing);
      this.panelClose.ResumeLayout(false);
      this.panelSend.ResumeLayout(false);
      this.panelSend.PerformLayout();
      this.panel2.ResumeLayout(false);
      this.panelInfo.ResumeLayout(false);
      this.panelInfo.PerformLayout();
      this.panel3.ResumeLayout(false);
      this.panel1.ResumeLayout(false);
      this.panel1.PerformLayout();
      this.panelInfoSend.ResumeLayout(false);
      this.panelInfoSend.PerformLayout();
      this.panel4.ResumeLayout(false);
      this.panel4.PerformLayout();
      this.ResumeLayout(false);

        }
		#endregion

        // This event is set during sending 
        private System.Threading.ManualResetEvent mIsSendingEvent = 
                                           new System.Threading.ManualResetEvent(false);

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FormMain());
		}

        private void FormMain_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
          // Stop the matrix
          CMatrixSubsystem.Stop();
        }

        private void SendProcess()
        {
          mIsSendingEvent.Set();
          btnSend.Enabled = false;
          try
          {
            // Get a number of messages to send. Here can be an exception
            int n = Convert.ToInt32(txtMsgNum.Text);
            // Create a message
            zx.matrix.CStdMessage msg = new zx.matrix.CStdMessage("test");
            for (int i = 1; i <= n && mIsSendingEvent.WaitOne(0, true); i++)
            {
              zx.pl.CPropertyList p = msg.Root.AddProperty(zx.pl.CDataContainer.TypeString, "text");
              p.DC.SetStringValue(i.ToString() + " " + txtMsg.Text);
              CMatrixSubsystem.Send(msg);
              labelNumberOfSent.Text = "Sent " + i.ToString() + " from " + n.ToString();
            } // for
          } // try
          catch (System.Exception)
          {
            // Display an error in a red color
            System.Drawing.Color oldcolor = labelNumberOfSent.ForeColor;
            labelNumberOfSent.ForeColor = System.Drawing.Color.Red;
            labelNumberOfSent.Text = "Invalid number: " + txtMsgNum.Text;
            System.Threading.Thread.Sleep(1000);
            // Restore original color
            labelNumberOfSent.ForeColor = oldcolor;
            goto ___EXIT;
          }
          System.Threading.Thread.Sleep(1000);
___EXIT:          
          labelNumberOfSent.Text = "";
          btnSend.Enabled = CMatrixSubsystem.IsConnected();
          mIsSendingEvent.Reset();
        }
        private void btnSend_Click(object sender, System.EventArgs e)
        {
          // Start send process
          (new System.Threading.Thread(new System.Threading.ThreadStart(SendProcess))).Start();
        }

        private void btnClose_Click(object sender, System.EventArgs e)
        {
            Close();
        }

        private void btnConnectionApply_Click(object sender, System.EventArgs e)
        {
          // Here I lock the button to avoid of friquent clicking
          btnConnectionApply.Enabled = false;
          CMatrixSubsystem.SetAvailableHosts(tbAvailableHosts.Text);
          System.Threading.Thread.Sleep(2000);
          btnConnectionApply.Enabled = true;
        }

	}

}
